Index: /trunk/gli/src/org/greenstone/gatherer/cdm/ArgumentConfiguration.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/cdm/ArgumentConfiguration.java	(revision 4931)
+++ /trunk/gli/src/org/greenstone/gatherer/cdm/ArgumentConfiguration.java	(revision 4932)
@@ -6,13 +6,7 @@
  * University of Waikato, New Zealand.
  *
- * <BR><BR>
- *
  * Author: John Thompson, Greenstone Digital Library, University of Waikato
  *
- * <BR><BR>
- *
  * Copyright (C) 1999 New Zealand Digital Library Project
- *
- * <BR><BR>
  *
  * This program is free software; you can redistribute it and/or modify
@@ -21,12 +15,8 @@
  * (at your option) any later version.
  *
- * <BR><BR>
- *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
- *
- * <BR><BR>
  *
  * You should have received a copy of the GNU General Public License
@@ -35,48 +25,10 @@
  *########################################################################
  */
-
- 
-
-
-
-
-/* GPL_HEADER */
 package org.greenstone.gatherer.cdm;
-/**************************************************************************************
- * Title:        Gatherer
- * Description:  The Gatherer: a tool for gathering and enriching a digital collection.
- * Company:      The University of Waikato
- * Written:      01/05/02
- * Revised:      16/08/02 Optimized and Commented. Added destructor.
- **************************************************************************************/
-import java.awt.BorderLayout;
-import java.awt.Color;
-import java.awt.Component;
-import java.awt.Dimension;
-import java.awt.GridLayout;
-import java.awt.Toolkit;
-import java.awt.event.ActionEvent;
-import java.awt.event.ActionListener;
-import java.awt.event.ItemEvent;
-import java.awt.event.ItemListener;
-import java.awt.event.KeyEvent;
-import java.util.ArrayList;
-import java.util.Collections;
-import java.util.HashMap;
-import java.util.Iterator;
-import javax.swing.BorderFactory;
-import javax.swing.BoxLayout;
-import javax.swing.DefaultListModel;
-import javax.swing.JButton;
-import javax.swing.JCheckBox;
-import javax.swing.JComboBox;
-import javax.swing.JComponent;
-import javax.swing.JDialog;
-import javax.swing.JLabel;
-import javax.swing.JList;
-import javax.swing.JOptionPane;
-import javax.swing.JPanel;
-import javax.swing.JScrollPane;
-import javax.swing.JTextField;
+
+import java.awt.*;
+import java.awt.event.*;
+import java.util.*;
+import javax.swing.*;
 import org.greenstone.gatherer.Gatherer;
 import org.greenstone.gatherer.cdm.Argument;
@@ -97,12 +49,4 @@
  * @see org.greenstone.gatherer.cdm.PlugIn
  */
-// ####################################################################################
-// Optimization                          Saving
-// ####################################################################################
-// Vector -> ArrayList                   + Processor
-// Hashtable -> HashMap                  + Processor
-// Remove several global references      + Memory (1Kb+)
-// ####################################################################################
-
 public class ArgumentConfiguration
     extends ModalDialog
@@ -114,8 +58,4 @@
     /** Whether we have successfully edited the arguments associated with the ArgumentContainer or if we have failed to enter required arguments and have instead cancelled (which would cause argument additions to roll back). */
     private boolean success = false;
-    /** A reference to the main CollectionDesignManager class for access to other managers. */
-    private CollectionDesignManager manager = null;
-    /** A reference to the Gatherer. */
-    private Gatherer gatherer = null;
     /** A button to cancel this dialog. */
     private JButton cancel = null;
@@ -137,14 +77,10 @@
     static final private Dimension SIZE = new Dimension(800, 425);
     /** Constructor.
-     * @param gatherer A reference to the <strong>Gatherer</strong>.
-     * @param manager The <strong>CollectionDesignManager</strong> for access to other configuration managers.
      * @param data The plugin or classifier whose arguments we are configuring, in the form of its supported <strong>ArgumentContainer</strong> interface.
      * @see org.greenstone.gatherer.Configuration
      */
-    public ArgumentConfiguration(Gatherer gatherer, CollectionDesignManager manager, ArgumentContainer data) {
-	super(gatherer.g_man);
+    public ArgumentConfiguration(ArgumentContainer data) {
+	super(Gatherer.g_man);
 	this.data = data;
-	this.gatherer = gatherer;
-	this.manager = manager;
 	this.self = this;
 	String custom_str = data.getCustom();
@@ -210,5 +146,5 @@
 
 	// Display on screen.
-	Dimension screen_size = gatherer.config.screen_size;
+	Dimension screen_size = Gatherer.config.screen_size;
 	setLocation((screen_size.width - SIZE.width) / 2, (screen_size.height - SIZE.height) / 2);
 	screen_size = null;
@@ -223,7 +159,5 @@
 	if(event.getSource() == ok) {
 	    // Update the details stored in the data objects arguments.
-	    if(custom.getText().length() > 0) {
-		data.setCustom(custom.getText());
-	    }
+	    data.setCustom(custom.getText());
 	    // Loop through each of the controls in the central pane, updating the matching argument as necessary.
 	    for(int i = 0; i < central_pane.getComponentCount(); i++) {
@@ -248,6 +182,4 @@
 	custom = null;
 	data = null;
-	gatherer = null;
-	manager = null;
 	ok = null;
 	self = null;
@@ -285,5 +217,5 @@
 	  */
     private void generateControls() {
-	ArrayList arguments = data.getArguments();
+	ArrayList arguments = data.getArguments(true, false);
 	int total_height = 250;
 	int size = arguments.size();
@@ -317,5 +249,5 @@
 	    key = "CDM.ArgumentConfiguration." + key;
 	}
-	return gatherer.dictionary.get(key, args);
+	return Gatherer.dictionary.get(key, args);
     }
     /** This class encapsulates all the technical difficulty of creating a specific control based on an Argument. */
@@ -324,4 +256,7 @@
 	/** The Argument this control will be based on. */
 	private Argument argument = null;
+
+	private Color colour_one = Gatherer.config.getColor("coloring.collection_heading_background", false);
+	private Color colour_two = Gatherer.config.getColor("coloring.collection_tree_background", false);
 	/** One of a possible two buttons available for adding to this control. */
 	private JButton one = null;
@@ -345,10 +280,10 @@
 	public ArgumentControl(Argument argument) {
 	    this.argument = argument;
-	    String tip = "<html>" + argument.getDesc() + "</html>";
+	    String tip = "<html>" + argument.getDescription() + "</html>";
 	    tip = Utility.formatHTMLWidth(tip, 60);
 	    // If this is the first control, there is no history.
 	    if(previous_owner == null) {
 		previous_owner = argument.getOwner();
-		addHeader(previous_owner, Color.white);
+		addHeader(previous_owner, colour_one);
 	    }
 	    // Otherwise if the owner of the control has changed since the last argument, toggle the colouring of the control.
@@ -356,12 +291,12 @@
 		coloured = !coloured;
 		previous_owner = argument.getOwner();
-		addHeader(previous_owner, (coloured ? Gatherer.config.getColor("coloring.collection_tree_background", false) : Color.white));
+		addHeader(previous_owner, (coloured ? colour_two : colour_one));
 	    }
 	    // Create
 	    if(coloured) {
-		setBackground(Gatherer.config.getColor("coloring.collection_tree_background", false));
+		setBackground(colour_one);
 	    }
 	    else {
-		setBackground(Color.white);
+		setBackground(colour_two);
 	    }
 	    JLabel owner_label = new JLabel(argument.getOwner());
@@ -382,5 +317,5 @@
 	    case Argument.ENUM:
 		// Build an option model, wrapping each entry of the list table.
-		HashMap arg_list = argument.getList();
+		HashMap arg_list = argument.getOptions();
 		ArrayList options_model = new ArrayList();
 		Iterator it = arg_list.keySet().iterator();
@@ -405,5 +340,5 @@
 		break;
 	    case Argument.HIERARCHY:
-		value = new JComboBox(gatherer.c_man.msm.getAssignedElements(true));
+		value = new JComboBox(Gatherer.c_man.getCollection().msm.getAssignedElements(true));
 		/** @TODO - figure out a smarter way of allowing Greenstone extracted metadata to be selected. */
 		((JComboBox)value).setEditable(true);
@@ -450,19 +385,19 @@
 		break;
 	    case Argument.LANGUAGE:
-		value = new JComboBox(manager.languages.getLanguageCodes().toArray());
+		value = new JComboBox(CollectionDesignManager.language_manager.getLanguageCodes().toArray());
 		// Now ensure we have the existing value or default value selected if either exist.
 		Language selected = null;
 		if(existing_value != null) {
-		    selected = manager.languages.getLanguage(existing_value, false);
+		    selected = CollectionDesignManager.language_manager.getLanguage(existing_value);
 		}
 		else if(default_value != null) {
-		    selected = manager.languages.getLanguage(default_value, false);
+		    selected = CollectionDesignManager.language_manager.getLanguage(default_value);
 		}
 		if(selected != null) {
-		    ((JComboBox)value).setSelectedItem(selected);
+		    ((JComboBox)value).setSelectedItem(selected.getCode());
 		}
 		break;
-	    case Argument.METADATA:
-		value = new JComboBox(gatherer.c_man.msm.getAssignedElements());
+	    case Argument.METADATUM:
+		value = new JComboBox(Gatherer.c_man.getCollection().msm.getAssignedElements());
 		/** @TODO - figure out a smarter way of allowing Greenstone extracted metadata to be selected. */
 		((JComboBox)value).setEditable(true);
@@ -475,8 +410,8 @@
 		}
 		break;
-	    case Argument.METADATUM:
+	    case Argument.METADATA:
 		// Comma separated metadata values.
 		ArrayList values = argument.getValues();
-		value = new JComboBox(gatherer.c_man.msm.getAssignedElements());
+		value = new JComboBox(Gatherer.c_man.getCollection().msm.getAssignedElements());
 		DefaultListModel model = new DefaultListModel();
 		list = new JList(model);
@@ -566,4 +501,5 @@
 	    add(inner_pane, BorderLayout.CENTER);
 	}
+
 	public Object getValue() {
 	    if(value instanceof JComboBox) {
@@ -650,13 +586,10 @@
 		    // Kinda lucked out here. Its impossible not to choose an entry from these comboboxes as they are restricted.
 		    return true;
-		case Argument.METADATA:
-		    // I feel like a cast-away
-		    argument.setElementValue((ElementWrapper)((JComboBox)value).getSelectedItem());
-		    return true;
+		case Argument.METADATUM:
 		case Argument.HIERARCHY:
 		    argument.setValue(((JComboBox)value).getSelectedItem().toString());
 		    // Kinda lucked out here. Its impossible not to choose an entry from these comboboxes as they are restricted.
 		    return true;
-		case Argument.METADATUM:
+		case Argument.METADATA:
 		    DefaultListModel model = (DefaultListModel)list.getModel();
 		    ArrayList values = new ArrayList();
@@ -743,11 +676,11 @@
 		this.target = target;
 	    }
-	    /** When the add button is clicked, we attempt to add the selected metadata from the source into the target.
-	     * @param event An <strong>ActionEvent</strong> containing information about the event.
-	     * @see org.greenstone.gatherer.msm.ElementWrapper
-	     */
+				/** When the add button is clicked, we attempt to add the selected metadata from the source into the target.
+				 * @param event An <strong>ActionEvent</strong> containing information about the event.
+				 * @see org.greenstone.gatherer.msm.ElementWrapper
+				 */
 	    public void actionPerformed(ActionEvent event) {
 		ElementWrapper element = (ElementWrapper) source.getSelectedItem();
-		String name = element.getName();
+		String name = element.toString();
 		if(!model.contains(name)) {
 		    boolean found = false;
Index: /trunk/gli/src/org/greenstone/gatherer/cdm/ArgumentContainer.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/cdm/ArgumentContainer.java	(revision 4931)
+++ /trunk/gli/src/org/greenstone/gatherer/cdm/ArgumentContainer.java	(revision 4932)
@@ -6,13 +6,7 @@
  * University of Waikato, New Zealand.
  *
- * <BR><BR>
- *
  * Author: John Thompson, Greenstone Digital Library, University of Waikato
  *
- * <BR><BR>
- *
  * Copyright (C) 1999 New Zealand Digital Library Project
- *
- * <BR><BR>
  *
  * This program is free software; you can redistribute it and/or modify
@@ -21,12 +15,8 @@
  * (at your option) any later version.
  *
- * <BR><BR>
- *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
- *
- * <BR><BR>
  *
  * You should have received a copy of the GNU General Public License
@@ -35,18 +25,8 @@
  *########################################################################
  */
-
- 
-
-
-
-
-/* GPL_HEADER */
 package org.greenstone.gatherer.cdm;
 /**************************************************************************************
- * Title:        Gatherer
- * Description:  The Gatherer: a tool for gathering and enriching a digital collection.
- * Company:      The University of Waikato
  * Written:      20/05/02
- * Revised:
+ * Revised:      03/07/03
  **************************************************************************************/
 import java.util.ArrayList;
@@ -57,17 +37,19 @@
 public interface ArgumentContainer {
     /** Method to retrieve the list of arguments from this container. Note that this method returns both the containers arguments plus its 'supers' arguments if any, and alphabetically orders them.
-     * @return The arguments within a <strong>ArrayList</strong>.
+     * @param include_normal true to filter so normal arguments are returned
+     * @param include_custom true to filter so custom arguments are returned
+     * @return the arguments within a ArrayList
      */
-    public ArrayList getArguments();
+    public ArrayList getArguments(boolean include_normal, boolean include_custom);
     /** Method to retrieve this containers custom argument string.
-     * @return The custom arguments as a <strong>String</strong>.
+     * @return the custom arguments as a String
      */
     public String getCustom();
     /** Method to retrieve the name associated with this argument container.
-     * @return The name as a <strong>String</strong>.
+     * @return the name as a String
      */
     public String getName();
     /** Method to set the custom arguments string.
-     * @param custom The new custom argument <strong>String</strong>.
+     * @param custom the new custom argument String
      */
     public void setCustom(String custom);
